Package org.apache.tools.ant

# Class TaskAdapter

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.TaskAdapter

All Implemented Interfaces:
  `Cloneable`, `TypeAdapter`

public class TaskAdapter extends Task implements TypeAdapter
Uses introspection to "adapt" an arbitrary Bean which doesn't itself extend Task, but still contains an execute method and optionally a setProject method.

## Field Summary

### Fields inherited from class org.apache.tools.ant.Task

`target, taskName, taskType, wrapper`

### Fields inherited from class org.apache.tools.ant.ProjectComponent

`description, location, project`

## Constructor Summary

Constructors
Constructor
Description
`TaskAdapter()`
No-arg constructor for reflection.
`TaskAdapter(Object proxy)`
Constructor for given proxy.

## Method Summary

Modifier and Type
Method
Description
`void`
`checkProxyClass(Class<?> proxyClass)`
Check if the proxy class is a valid class to use with this adapter.
`static void`
`checkTaskClass(Class<?> taskClass, Project project)`
Checks whether or not a class is suitable to be adapted by TaskAdapter.
`void`
`execute()`
Executes the proxied task.
`Object`
`getProxy()`
Returns the target object being proxied.
`void`
`setProxy(Object o)`
Sets the target object to proxy for.

### Methods inherited from class org.apache.tools.ant.Task

`bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`

### Methods inherited from class org.apache.tools.ant.ProjectComponent

`clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.tools.ant.TypeAdapter

`getProject, setProject`

## Constructor Details

### TaskAdapter

public TaskAdapter()
No-arg constructor for reflection.

### TaskAdapter

public TaskAdapter(Object proxy)
Constructor for given proxy. So you could write easier code

     myTaskContainer.addTask(new TaskAdapter(myProxy));

Parameters:
  `proxy` - The object which Ant should use as task.

## Method Details

### checkTaskClass

public static void checkTaskClass(Class<?> taskClass, Project project)
Checks whether or not a class is suitable to be adapted by TaskAdapter. If the class is of type Dispatchable, the check is not performed because the method that will be executed will be determined only at runtime of the actual task and not during parse time. This only checks conditions which are additionally required for tasks adapted by TaskAdapter. Thus, this method should be called by Project.checkTaskClass. Throws a BuildException and logs as Project.MSG_ERR for conditions that will cause the task execution to fail. Logs other suspicious conditions with Project.MSG_WARN.

Parameters:
  `taskClass` - Class to test for suitability. Must not be `null`.
  `project` - Project to log warnings/errors to. Must not be `null`.
See Also:
  - `Project.checkTaskClass(Class)`

### checkProxyClass

public void checkProxyClass(Class<?> proxyClass)
Check if the proxy class is a valid class to use with this adapter. The class must have a public no-arg "execute()" method.

Specified by:
  `checkProxyClass` in interface `TypeAdapter`
Parameters:
  `proxyClass` - the class to check.

### execute

public void execute() throws BuildException
Executes the proxied task.

Overrides:
  `execute` in class `Task`
Throws:
  `BuildException` - if the project could not be set or the method could not be executed.

### setProxy

public void setProxy(Object o)
Sets the target object to proxy for.

Specified by:
  `setProxy` in interface `TypeAdapter`
Parameters:
  `o` - The target object. Must not be `null`.

### getProxy

public Object getProxy()
Returns the target object being proxied.

Specified by:
  `getProxy` in interface `TypeAdapter`
Returns:
  the target proxy object.